
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

// version with only two pipe objects


int tochild[2];
int fromchild[2];
int nb_procs;

int get_random() {
	srand( getpid() % 17 );
	return rand() % 1024;
}

void node(int me) {

	int nb = get_random();
	int onb;

	printf("me = %d nb=%d\n", me, nb);

	if( me == 0 ) {

		close( tochild[0] );
		write( tochild[1], &nb, sizeof(int));

		close( fromchild[1] );
		read(  fromchild[0], &onb, sizeof(int));

		printf("winner is %d\n", onb);

	} else {

		close(tochild[1]);
		read(tochild[0], &onb, sizeof(int));

//		printf("me %d: read %d from %d\n", me, onb, me-1);

		if( onb > nb ) {
			nb = onb;
		}
		close(fromchild[0]);
		write(fromchild[1], &nb, sizeof(int));

	}

	exit(0);
}

int main(int argc, char *argv[]) {
	int pid;
	int i;
	int pcopy[2];

	if (argc != 2) {
		fprintf(stderr, "Usage: e4 nb\n");
		exit(-1);
	}

	nb_procs = atoi(argv[1]);

	// create one pipe in parent
	pipe(tochild);
	pcopy[0] = tochild[0];
	pcopy[1] = tochild[1];

	for(i = 1; i<nb_procs; i++) {

		// create one pipe between each child
		pipe(fromchild);

		pid = fork();

		if( pid == 0 ) {
			node(i);
		} else {
			if( i < nb_procs-1 ) {
				tochild[0] = fromchild[0];
				tochild[1] = fromchild[1];
			} else {
				tochild[0] = pcopy[0];
				tochild[1] = pcopy[1];
			}
		}

	}

	node(0);

	return 0;
}
